<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>JR3.30</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
</head>

<body>

    <div class="container">
        <h1 class="text-center mt-4">Danh sách học viên</h1>

        <p>
            <a href="addStudent.html" class="btn btn-success"><i class="fa fa-plus-circle"></i> Thêm học viên</a>
        </p>

        <div class="table-responsive">
            <table id="tbl-student" class="table table-striped table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th>Họ tên</th>
                        <th>Ngày sinh</th>
                        <th>Email</th>
                        <th>Số điện thoại</th>
                        <th></th>
                    </tr>
                </thead>

                <tbody>
                    <tr>
                        <td colspan="5" class="text-center">
                            <div class="spinner-border" role="status">
                                <span class="sr-only">Loading...</span>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="container">
            <div id="modal-delete" class="modal" tabindex="-1" role="dialog">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Xóa học viên</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <p>Bạn có chắc muốn xóa học viên này!</p>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary btn-delete">Xác nhận</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://devcamp-student.herokuapp.com/users/";
    var gIdDelete = "";
    $(document).ready(function () {
        onPageLoading();

        // Hàm ấn nút xác nhận để xóa học viên
        $('.btn-delete').on('click',function(){
            onBtnConFirmClick();
        })
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    function onPageLoading() {
        callApiGetAllStudent()
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function callApiGetAllStudent() {
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            data: "json",
            success: function (res) {
                //Load thông tin vào bảng
                loadDataToTable(res);
                //Hàm sự kiện lắng nghe ấn nút
                addEventListener(res);

            }
        })
    }

    // Hàm lắng nghe sự kiện ấn nút
    function addEventListener() {
        "use strict";
        $('#tbl-student').on('click', '.edit-student', function () {
            onBtnEditClick(this);
        })
        $('#tbl-student').on('click', '.delete-student', function () {
            onBtnDeleteClick(this);
        })
    }
   
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadDataToTable(paramData) {
        "use strict";
        $('#tbl-student').find('tbody').remove();
        for (let bI of paramData) {
            $('<tr>').append(
                $('<td>').text(bI.name),
                $('<td>').text(bI.birthday),
                $('<td>').text(bI.email),
                $('<td>').text(bI.phone),

                $(`<a href="#">`)
                    .addClass('text-info edit-student')
                    .html(`<i class="fas fa-edit"></i> Chỉnh sửa`).data('id', bI.id),
                " | ",
                $(`<a href="#">`)
                    .addClass('text-danger delete-student')
                    .html(`<i class="fas fa-trash-alt"></i> Xóa`).data('id', bI.id),
            ).appendTo($('#tbl-student'));
        }
    }

    // Hàm chỉnh sửa thông tin học viên
    function onBtnEditClick(paramElement) {
        "use strict";
        var vId = $(paramElement).data('id');
        console.log("Sửa thông tin học viên có Id: " + vId);
        window.location.href = "editStudent.html" + "?" + "id=" + vId;
    }

    // Hàm sự kiện ấn nút Delete
    function onBtnDeleteClick(paramElement){
        "use strict";
        var vId = $(paramElement).data('id');
        gIdDelete = vId;
        console.log('Xóa học viên ID: ' + gIdDelete);
        $('#modal-delete').modal('show');
    }

    // Hàm xử lý ấn nút xác nhận xóa học viên
    function onBtnConFirmClick(){
        "use strict";
        $.ajax({
            url:gBASE_URL + gIdDelete,
            type:"DELETE",
            success:function(res){
                console.log(res);
                alert("Xóa thành công!");
                //Quay trở về trang
                location.reload();
            },
            error:function(error){
                console.log(error.status);
                alert("Xóa thất bại!");
            }
        })
    }

</script>

</html>